<template>
    <div class="chat-list">
        <div class="message" v-for="(chat, index) in sortedChats" v-bind:key="index">
            <div class="user">
                {{chat.sender.name}} <span class="time">{{chat.created_at}}</span>
            </div>
            <div class="message-body">
                {{chat.subject}}
            </div>
        </div>
    </div>
</template>

<script>
    import BusEvent from '../../bus'
    export default {
        data(){
            return{
                chats : []
            }
        },
        props: ['recievername', 'recieverid'],
        mounted() {
            this.getChats();
            BusEvent.$on('chat.sent', (newChat)=>{
                if((newChat.sender.id !== window.Laravel.user.id && newChat.sender.id !== this.recieverid) ||
                (newChat.reciever.id !== window.Laravel.user.id && newChat.reciever.id !== this.recieverid)){
                    return
                }
                this.chats.push(newChat)
                this.scrollToBottom()
            })
        },
        computed:{
            sortedChats: function() {
                function time(a, b) {
                    if (a.created_at < b.created_at) return -1;
                    if (a.created_at > b.created_at) return 1;

                    return 0;
                }
                return this.chats.sort(time);
            }
        },
        methods : {
            getChats(){
                axios.post('/chat-messages', {'target_id' : this.recieverid}).then(response => {
                    let raw = response.data;
                    raw = [...raw['sent'], ...raw['recieved']]
                    this.chats = raw.sort((a, b) => a['created_at']-b['created_at']);
                    this.scrollToBottom()
                });
            },
            scrollToBottom(){
                setTimeout(function(){
                    let chatList = $('.chat-list')[0];
                    chatList.scrollTop = chatList.scrollHeight
                },1);
            }
        }
    }
</script>

<style lang="scss">
    .chat-list{
        height: 300px;
        overflow: auto;
    }
    .message{
        margin-top: 5px;
    }
    .time{
        font-weight: 800;    
    }
    .message-body{
        font-size: 1.2rem;
    }
</style>